import { ASTNode, Directives, State, Watchers } from '@models/structs';
export declare class Component {
    state: State;
    directives: Directives;
    watchers: Watchers;
    ast: ASTNode[];
    constructor(state?: State, watchers?: Watchers);
    mount(el: HTMLElement | string): void;
    render(props?: string[]): void;
}
export declare class ComponentFactory {
    state: () => State;
    watchers: Watchers;
    constructor(state: () => State);
    init(el: HTMLElement | string): Component;
    watch(name: string, callback: () => void): void;
}
export declare const component: (state: () => State) => ComponentFactory;
export default component;
