import { KV } from './generics';
export declare type Directives = KV<(props: DirectiveProps) => void>;
export declare type Watchers = KV<() => void>;
export declare type Refs = KV<HTMLElement>;
export declare type State = KV<unknown>;
export declare type DirectiveKV = KV<DirectiveData>;
export interface DirectiveData {
    compute: (state: KV<unknown>, event?: Event) => any;
    value: string;
    deps: string[];
}
export interface DirectiveProps {
    el: HTMLElement;
    parts: string[];
    data: DirectiveData;
    state: State;
    node?: ASTNode;
}
export interface ASTNode {
    directives: DirectiveKV;
    deps: string[];
    el: HTMLElement;
    type: ASTNodeType;
}
export declare enum ASTNodeType {
    NULL = -1,
    STATIC = 0,
    DYNAMIC = 1
}
